#include "pt.h"

// RX and TX FIFO buffer sizes (Must be power of 2)
#define BUFFER_SIZE 16
#define BUFFER_MASK (BUFFER_SIZE - 1) 

// Structure to pass data to the full duplex serial cog driver
struct fds_mailbox
{
        //unsigned int stack[20];
        unsigned int txPin;
        unsigned int rxPin;
        unsigned int baudRate;
	char rxBuffer[BUFFER_SIZE]; // RX and TX FIFO buffers and pointers
	char txBuffer[BUFFER_SIZE];
	int  rxHead;
	int  rxTail;
	int  txHead;
	int  txTail;
	struct pt pt_tx;            // Proto thread state variables which hold the state
	struct pt pt_rx;            // of the to threads used by fds.
};

